#include <iostream>
#include <stdlib.h>
#include "chunkexpressionlib.h"
using namespace std;

int main (int argc, const char * argv[]) {
    string text, op, chunk, starts, ends, newtext;
    int start, end;
    char op2;
    vector<chunk_reference> q;
    if (argc == 1)
    {
        cout << "Usage:" << endl;
        cout << "     cxl text operation chunktype [start] [end] [newtext]" << endl;
        cout << "     cxl text xoperation chunk-expression [newtext]" << endl;
        return 0;
    }
    if (argc < 4)
    {
        cout << "Invalid parameter count." << endl;
        return 0;
    }
    text = argv[1];
    op = argv[2];
    op2 = cxl_tolower(op[0]);
    chunk = argv[3];
    /* OP tells us what to do. We can do the following:
        c - count chunks
        s - find start
        e - find end
        d - delete
        g - get
        p - put into
        b - put before
        a - put after
        x - compound operation (using a string)
    */
    if (! ((op2=='c')||(op2=='s')||(op2=='e')||(op2=='d')||(op2=='g')||(op2=='p')||(op2=='b')||(op2=='a')||(op2=='x')) )
    {
        cout << "Invalid operation." << endl;
        return 0;
    }
    if ( (op2=='c') && (argc != 4) )
    {
        cout << "Invalid parameter count for this operation." << endl;
        return 0;
    }
    if ( ((op2=='s')||(op2=='e')||(op2=='d')||(op2=='g')) && (argc != 6) )
    {
        cout << "Invalid parameter count for this operation." << endl;
        return 0;
    }
    if ( ((op2=='p')||(op2=='b')||(op2=='a')) && (argc != 7) )
    {
        cout << "Invalid parameter count for this operation." << endl;
        return 0;
    }
    switch (op2) {
    case 'c':
        cout << cxl_count_chunks(text, chunk) << endl;
        break;
    case 's':
        starts = argv[4];
        ends = argv[5];
        if (starts == "any")
            { start = 0x80000001; }
        else if (starts == "mid")
            { start = 0x7FFFFFFF; }
        else
            { start = atoi(starts.c_str()); }
        if (ends == "any")
            { end = 0x80000001; }
        else if (ends == "mid")
            { end = 0x7FFFFFFF; }
        else
            { end = atoi(ends.c_str()); }
        cout << cxl_chunk_start(text, chunk, start, end) << endl;
        break;
    case 'e':
        starts = argv[4];
        ends = argv[5];
        if (starts == "any")
            { start = 0x80000001; }
        else if (starts == "mid")
            { start = 0x7FFFFFFF; }
        else
            { start = atoi(starts.c_str()); }
        if (ends == "any")
            { end = 0x80000001; }
        else if (ends == "mid")
            { end = 0x7FFFFFFF; }
        else
            { end = atoi(ends.c_str()); }
        cout << cxl_chunk_end(text, chunk, start, end) << endl;
        break;
    case 'd':
        starts = argv[4];
        ends = argv[5];
        if (starts == "any")
            { start = 0x80000001; }
        else if (starts == "mid")
            { start = 0x7FFFFFFF; }
        else
            { start = atoi(starts.c_str()); }
        if (ends == "any")
            { end = 0x80000001; }
        else if (ends == "mid")
            { end = 0x7FFFFFFF; }
        else
            { end = atoi(ends.c_str()); }
        cout << cxl_delete_chunk(text, chunk, start, end) << endl;
        break;
    case 'g':
        starts = argv[4];
        ends = argv[5];
        if (starts == "any")
            { start = 0x80000001; }
        else if (starts == "mid")
            { start = 0x7FFFFFFF; }
        else
            { start = atoi(starts.c_str()); }
        if (ends == "any")
            { end = 0x80000001; }
        else if (ends == "mid")
            { end = 0x7FFFFFFF; }
        else
            { end = atoi(ends.c_str()); }
        cout << cxl_get_chunk(text, chunk, start, end) << endl;
        break;
    case 'p':
        starts = argv[4];
        ends = argv[5];
        if (starts == "any")
            { start = 0x80000001; }
        else if (starts == "mid")
            { start = 0x7FFFFFFF; }
        else
            { start = atoi(starts.c_str()); }
        if (ends == "any")
            { end = 0x80000001; }
        else if (ends == "mid")
            { end = 0x7FFFFFFF; }
        else
            { end = atoi(ends.c_str()); }
        newtext = argv[6];
        cout << cxl_put_into_chunk(text, chunk, start, end, newtext) << endl;
        break;
    case 'b':
        starts = argv[4];
        ends = argv[5];
        if (starts == "any")
            { start = 0x80000001; }
        else if (starts == "mid")
            { start = 0x7FFFFFFF; }
        else
            { start = atoi(starts.c_str()); }
        if (ends == "any")
            { end = 0x80000001; }
        else if (ends == "mid")
            { end = 0x7FFFFFFF; }
        else
            { end = atoi(ends.c_str()); }
        newtext = argv[6];
        cout << cxl_put_before_chunk(text, chunk, start, end, newtext) << endl;
        break;
    case 'a':
        starts = argv[4];
        ends = argv[5];
        if (starts == "any")
            { start = 0x80000001; }
        else if (starts == "mid")
            { start = 0x7FFFFFFF; }
        else
            { start = atoi(starts.c_str()); }
        if (ends == "any")
            { end = 0x80000001; }
        else if (ends == "mid")
            { end = 0x7FFFFFFF; }
        else
            { end = atoi(ends.c_str()); }
        newtext = argv[6];
        cout << cxl_put_after_chunk(text, chunk, start, end, newtext) << endl;
        break;
    case 'x':
        op2 = cxl_tolower(op[1]);
        if (! ((op2=='s')||(op2=='e')||(op2=='d')||(op2=='g')||(op2=='p')||(op2=='b')||(op2=='a')) )
        {
            cout << "Invalid operation." << endl;
            return 0;
        }
        if ( ((op2=='s')||(op2=='e')||(op2=='d')||(op2=='g')) && (argc != 4) )
        {
            cout << "Invalid parameter count for this operation." << endl;
            return 0;
        }
        if ( ((op2=='p')||(op2=='b')||(op2=='a')) && (argc != 5) )
        {
            cout << "Invalid parameter count for this operation." << endl;
            return 0;
        }
        q = cxl_cexpr_partial_parse(chunk);
        switch (op2) {
        case 's':
            cout << cxl_cexpr_chunk_start(text, q) << endl;
            break;
        case 'e':
            cout << cxl_cexpr_chunk_end(text, q) << endl;
            break;
        case 'd':
            cout << cxl_cexpr_delete_chunk(text, q) << endl;
            break;
        case 'g':
            cout << cxl_cexpr_get_chunk(text, q) << endl;
            break;
        case 'p':
            newtext = argv[4];
            cout << cxl_cexpr_put_into_chunk(text, q, newtext) << endl;
            break;
        case 'b':
            newtext = argv[4];
            cout << cxl_cexpr_put_before_chunk(text, q, newtext) << endl;
            break;
        case 'a':
            newtext = argv[4];
            cout << cxl_cexpr_put_after_chunk(text, q, newtext) << endl;
            break;
        }
        break;
    }
    return 0;
}
